Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 782)
+++ admin/popup_posts.php	(revision 557)
@@ -17,11 +17,11 @@
 $q = !empty($_GET['q']) ? $_GET['q'] : null;
 
-$post_list = new adminPostMiniList($core);
+$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
+$nb_per_page =  10;
 
 $params = array();
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 $params['no_content'] = true;
-
-# - Limit, sortby and order filter
-$params = $post_list->applyFilters($params);
+$params['order'] = 'post_dt DESC';
 
 if ($q) {
@@ -43,5 +43,5 @@
 	$posts = $core->blog->getPosts($params);
 	$counter = $core->blog->getPosts($params,true);
-	$post_list->setItems($posts,$counter->f(0));
+	$post_list = new adminPostMiniList($core,$posts,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -49,5 +49,5 @@
 
 echo '<div id="form-entries">'; # I know it's not a form but we just need the ID
-$post_list->display();
+$post_list->display($page,$nb_per_page);
 echo '</div>';
 
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 782)
+++ admin/post.php	(revision 776)
@@ -573,14 +573,11 @@
 {
 	echo
-	'<table class="comments-list">'.
-	'<caption>'.__('Post comments and trackbacks').'</caption>'.
-	'<thead><tr>'.
-	'<th scope="col" colspan="2">'.__('Author').'</th>'.
-	'<th scope="col">'.__('Date').'</th>'.
-	'<th scope="col" class="nowrap">'.__('IP address').'</th>'.
-	'<th scope="col">'.__('Status').'</th>'.
-	'<th scope="col">&nbsp;</th>'.
-	'</tr></thead>'.
-	'<tbody>';
+	'<table class="comments-list"><tr>'.
+	'<th colspan="2">'.__('Author').'</th>'.
+	'<th>'.__('Date').'</th>'.
+	'<th class="nowrap">'.__('IP address').'</th>'.
+	'<th>'.__('Status').'</th>'.
+	'<th>&nbsp;</th>'.
+	'</tr>';
 	
 	while($rs->fetch())
@@ -610,5 +607,5 @@
 		'<td class="nowrap">'.
 		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,'','','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
-		'<th scope="row" class="maximal">'.html::escapeHTML($rs->comment_author).'</th>'.
+		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
 		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
 		'<td class="nowrap"><a href="comments.php?ip='.$rs->comment_ip.'">'.$rs->comment_ip.'</a></td>'.
@@ -620,7 +617,5 @@
 	}
 	
-	echo
-	'</tbody>'.
-	'</table>';
+	echo '</table>';
 }
 
Index: admin/posts.php
===================================================================
--- admin/posts.php	(revision 782)
+++ admin/posts.php	(revision 796)
@@ -48,4 +48,5 @@
 	# Filter form we'll put in html_block
 	$users_combo = $categories_combo = array();
+	$users_combo['-'] = $categories_combo['-'] = '';
 	while ($users->fetch())
 	{
@@ -62,5 +63,5 @@
 	$categories_combo[__('None')] = 'NULL';
 	while ($categories->fetch()) {
-		$categories_combo[str_repeat('&nbsp;&nbsp;',$categories->level-1).'&bull; '.
+		$categories_combo[str_repeat('&nbsp;&nbsp;',$categories->level-1).($categories->level-1 == 0 ? '' : '&bull; ').
 			html::escapeHTML($categories->cat_title).
 			' ('.$categories->nb_post.')'] = $categories->cat_id;
@@ -68,4 +69,5 @@
 	
 	$status_combo = array(
+	'-' => ''
 	);
 	foreach ($core->blog->getAllPostStatus() as $k => $v) {
@@ -74,16 +76,33 @@
 	
 	$selected_combo = array(
-	__('is selected') => '1',
-	__('is not selected') => '0'
+	'-' => '',
+	__('selected') => '1',
+	__('not selected') => '0'
 	);
 	
 	# Months array
+	$dt_m_combo['-'] = '';
 	while ($dates->fetch()) {
 		$dt_m_combo[dt::str('%B %Y',$dates->ts())] = $dates->year().$dates->month();
 	}
 	
+	$lang_combo['-'] = '';
 	while ($langs->fetch()) {
 		$lang_combo[$langs->post_lang] = $langs->post_lang;
 	}
+	
+	$sortby_combo = array(
+	__('Date') => 'post_dt',
+	__('Title') => 'post_title',
+	__('Category') => 'cat_title',
+	__('Author') => 'user_id',
+	__('Status') => 'post_status',
+	__('Selected') => 'post_selected'
+	);
+	
+	$order_combo = array(
+	__('Descending') => 'desc',
+	__('Ascending') => 'asc'
+	);
 }
 
@@ -119,63 +138,108 @@
 /* Get posts
 -------------------------------------------------------- */
-$post_list = new adminPostList($core);
-
-$params = new ArrayObject();
+$user_id = !empty($_GET['user_id']) ?	$_GET['user_id'] : '';
+$cat_id = !empty($_GET['cat_id']) ?	$_GET['cat_id'] : '';
+$status = isset($_GET['status']) ?	$_GET['status'] : '';
+$selected = isset($_GET['selected']) ?	$_GET['selected'] : '';
+$month = !empty($_GET['month']) ?		$_GET['month'] : '';
+$lang = !empty($_GET['lang']) ?		$_GET['lang'] : '';
+$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'post_dt';
+$order = !empty($_GET['order']) ?		$_GET['order'] : 'desc';
+
+$show_filters = false;
+
+$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
+$nb_per_page =  30;
+
+if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
+	if ($nb_per_page != $_GET['nb']) {
+		$show_filters = true;
+	}
+	$nb_per_page = (integer) $_GET['nb'];
+}
+
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 $params['no_content'] = true;
 
-$filterSet = new dcFilterSet('posts','posts.php');
-class monthComboFilter extends comboFilter {
-	public function applyFilter($params) {
-		$month=$this->values[0];
-		$params['post_month'] = substr($month,4,2);
-		$params['post_year'] = substr($month,0,4);
-	}
-}
-$filterSet
-	->addFilter(new comboFilter(
-		'users',__('Author'), __('Author'), 'user_id', $users_combo))
-	->addFilter(new categoryFilter(
-		'category',__('Category'), __('Category'), 'cat_id', $categories_combo))
-	->addFilter(new comboFilter(
-		'post_status',__('Status'), __('Status'), 'post_status', $status_combo))
-	->addFilter(new booleanFilter(
-		'post_selected',__('Selected'), __('The post : '),'post_selected', $selected_combo))
-	->addFilter(new comboFilter(
-		'lang',__('Lang'), __('Lang'), 'post_lang', $lang_combo))
-	->addFilter(new monthComboFilter(
-		'month',__('Month'),__('Month'), 'post_month', $dt_m_combo,array('singleval' => 1)))
-	->addFilter(new textFilter(
-		'search',__('Contains'),__('The entry contains'), 'search',20,255));
-
-$core->callBehavior('adminPostsFilters',$filterSet);
-$filterSet->setExtra($post_list);
-
-$filterSet->setup($_GET,$_POST);
+# - User filter
+if ($user_id !== '' && in_array($user_id,$users_combo)) {
+	$params['user_id'] = $user_id;
+	$show_filters = true;
+} else {
+	$user_id='';
+}
+
+# - Categories filter
+if ($cat_id !== '' && in_array($cat_id,$categories_combo)) {
+	$params['cat_id'] = $cat_id;
+	$show_filters = true;
+} else {
+	$cat_id='';
+}
+
+# - Status filter
+if ($status !== '' && in_array($status,$status_combo)) {
+	$params['post_status'] = $status;
+	$show_filters = true;
+} else {
+	$status='';
+}
+
+# - Selected filter
+if ($selected !== '' && in_array($selected,$selected_combo)) {
+	$params['post_selected'] = $selected;
+	$show_filters = true;
+} else {
+	$selected='';
+}
+
+# - Month filter
+if ($month !== '' && in_array($month,$dt_m_combo)) {
+	$params['post_month'] = substr($month,4,2);
+	$params['post_year'] = substr($month,0,4);
+	$show_filters = true;
+} else {
+	$month='';
+}
+
+# - Lang filter
+if ($lang !== '' && in_array($lang,$lang_combo)) {
+	$params['post_lang'] = $lang;
+	$show_filters = true;
+} else {
+	$lang='';
+}
+
+# - Sortby and order filter
+if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if ($order !== '' && in_array($order,$order_combo)) {
+		$params['order'] = $sortby.' '.$order;
+	} else {
+		$order='desc';
+	}
+	
+	if ($sortby != 'post_dt' || $order != 'desc') {
+		$show_filters = true;
+	}
+} else {
+	$sortby='post_dt';
+	$order='desc';
+}
 
 # Get posts
 try {
-	$nfparams = $params->getArrayCopy();
-	$filtered = $filterSet->applyFilters($params);
-	$core->callBehavior('adminPostsParams',$params);
 	$posts = $core->blog->getPosts($params);
 	$counter = $core->blog->getPosts($params,true);
-	if ($filtered) {
-		$totalcounter = $core->blog->getPosts($nfparams,true);
-		$page_title = sprintf(__('Entries / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
-	} else {
-		$page_title = __('Entries');
-		$filters_info = '';
-	}
-	$post_list->setItems($posts,$counter->f(0));
-} catch (Exception $e) {
-	$core->error->add($e->getMessage());
-}
-
+	$post_list = new adminPostList($core,$posts,$counter->f(0));
+} catch (Exception $e) {
+	$core->error->add($e->getMessage());
+}
 
 /* DISPLAY
 -------------------------------------------------------- */
 $starting_script = dcPage::jsLoad('js/_posts_list.js');
-
-$starting_script .= $filterSet->header();
+if (!$show_filters) {
+	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
+}
 
 dcPage::open(__('Entries'),$starting_script);
@@ -186,8 +250,49 @@
 	'<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; <span class="page-title">'.__('Entries').'</span></h2>'.
 	'<p class="top-add"><a class="button add" href="post.php">'.__('New entry').'</a></p>';
-
-	$filterSet->display();
+	
+	if (!$show_filters) {
+		echo '<p><a id="filter-control" class="form-control" href="#">'.
+		__('Filters').'</a></p>';
+	}
+	
+	echo
+	'<form action="posts.php" method="get" id="filters-form">'.
+	'<fieldset><legend>'.__('Filters').'</legend>'.
+	'<div class="three-cols">'.
+	'<div class="col">'.
+	'<label for="user_id">'.__('Author:').
+	form::combo('user_id',$users_combo,$user_id).'</label> '.
+	'<label for="cat_id">'.__('Category:').
+	form::combo('cat_id',$categories_combo,$cat_id).'</label> '.
+	'<label for="status">'.__('Status:').
+	form::combo('status',$status_combo,$status).'</label> '.
+	'</div>'.
+	
+	'<div class="col">'.
+	'<label for="selected">'.__('Selected:').
+	form::combo('selected',$selected_combo,$selected).'</label> '.
+	'<label for="month">'.__('Month:').
+	form::combo('month',$dt_m_combo,$month).'</label> '.
+	'<label for="lang">'.__('Lang:').
+	form::combo('lang',$lang_combo,$lang).'</label> '.
+	'</div>'.
+	
+	'<div class="col">'.
+	'<p><label for="sortby">'.__('Order by:').
+	form::combo('sortby',$sortby_combo,$sortby).'</label> '.
+	'<label for="order">'.__('Sort:').
+	form::combo('order',$order_combo,$order).'</label></p>'.
+	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
+	__('Entries per page').'</label></p> '.
+	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'</div>'.
+	'</div>'.
+	'<br class="clear" />'. //Opera sucks
+	'</fieldset>'.
+	'</form>';
+	
 	# Show posts
-	$post_list->display('<form action="posts_actions.php" method="post" id="form-entries">'.
+	$post_list->display($page,$nb_per_page,
+	'<form action="posts_actions.php" method="post" id="form-entries">'.
 	
 	'%s'.
@@ -199,11 +304,19 @@
 	form::combo('action',$combo_action).
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
+	form::hidden(array('user_id'),$user_id).
+	form::hidden(array('cat_id'),$cat_id).
+	form::hidden(array('status'),$status).
+	form::hidden(array('selected'),$selected).
+	form::hidden(array('month'),$month).
+	form::hidden(array('lang'),$lang).
+	form::hidden(array('sortby'),$sortby).
+	form::hidden(array('order'),$order).
+	form::hidden(array('page'),$page).
+	form::hidden(array('nb'),$nb_per_page).
 	$core->formNonce().
 	'</div>'.
 	'</form>'
 	);
-	}
-
+}
 
 dcPage::helpBlock('core_posts');
Index: admin/posts_actions.php
===================================================================
--- admin/posts_actions.php	(revision 782)
+++ admin/posts_actions.php	(revision 500)
@@ -31,5 +31,14 @@
 	{
 		$redir =
-		'posts.php?'.urldecode($_POST['f_query']);
+		'posts.php?user_id='.$_POST['user_id'].
+		'&cat_id='.$_POST['cat_id'].
+		'&status='.$_POST['status'].
+		'&selected='.$_POST['selected'].
+		'&month='.$_POST['month'].
+		'&lang='.$_POST['lang'].
+		'&sortby='.$_POST['sortby'].
+		'&order='.$_POST['order'].
+		'&page='.$_POST['page'].
+		'&nb='.$_POST['nb'];
 	}
 	
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 745)
+++ admin/preferences.php	(revision 821)
@@ -42,4 +42,5 @@
 }
 $user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
+$user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
 
 $default_tab = !empty($_GET['tab']) ? html::escapeHTML($_GET['tab']) : 'user-profile';
@@ -175,4 +176,5 @@
 		}
 		$core->auth->user_prefs->interface->put('iconset',(!empty($_POST['user_ui_iconset']) ? $_POST['user_ui_iconset'] : ''));
+		$core->auth->user_prefs->interface->put('nofavmenu',!empty($_POST['user_ui_nofavmenu']),'boolean');
 		
 		# Udate user
@@ -456,5 +458,9 @@
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
 form::checkbox('user_ui_enhanceduploader',1,$user_ui_enhanceduploader).' '.
-__('Activate enhanced uploader in media manager').'</label></p>';
+__('Activate enhanced uploader in media manager').'</label></p>'.
+
+'<p><label for="user_ui_nofavmenu" class="classic">'.
+form::checkbox('user_ui_nofavmenu',1,$user_ui_nofavmenu).' '.
+__('Hide My favorites menu').'</label></p>';
 
 if (count($iconsets_combo) > 1) {
Index: admin/services.php
===================================================================
--- admin/services.php	(revision 782)
+++ admin/services.php	(revision 323)
@@ -25,5 +25,4 @@
 $core->rest->addFunction('delMeta',array('dcRestMethods','delMeta'));
 $core->rest->addFunction('setPostMeta',array('dcRestMethods','setPostMeta'));
-$core->rest->addFunction('searchCommentAuthor',array('dcRestMethods','searchCommentAuthor'));
 $core->rest->addFunction('searchMeta',array('dcRestMethods','searchMeta'));
 
@@ -393,29 +392,4 @@
 		return $rsp;
 	}
-
-	public static function searchCommentAuthor($core,$get)
-	{
-		$q = !empty($get['q']) ? strtoupper($get['q']) : null;
-		
-		$strReq = 'SELECT DISTINCT C.comment_author '.
-			'FROM '.$core->prefix.'comment C '.
-			'INNER JOIN '.$core->prefix.'post P on C.post_id = P.post_id '.
-			'WHERE P.blog_id = \''.$core->blog->id.'\' '.
-			'AND UPPER(comment_author) like \'%'.$core->con->escape($q).'%\''
-			;
-		//echo $strReq;
-		$rs = $core->con->select($strReq);
-		$rsp = new xmlTag();
-		
-		while ($rs->fetch())
-		{
-			$author = new xmlTag('author');
-			$author->name=$rs->comment_author;
-			$rsp->insertNode($author);
-		}
-		
-		return $rsp;
-	}
-
 }
 ?>
Index: admin/user.php
===================================================================
--- admin/user.php	(revision 557)
+++ admin/user.php	(revision 860)
@@ -290,5 +290,13 @@
 if ($user_id)
 {
-	echo '<div class="clear fieldset"><h3>'.__('Permissions').'</h3>';
+	echo '<div class="clear fieldset"><h3>'.__('Permissions').'</h3>'.
+	'<form action="users_actions.php" method="post">'.
+	'<p><input type="submit" value="'.__('Add new permissions').'" />'.
+	form::hidden(array('redir'),'user.php?id='.$user_id).
+	form::hidden(array('action'),'blogs').
+	form::hidden(array('users[]'),$user_id).
+	$core->formNonce().
+	'</p>'.
+	'</form>';
 	
 	$permissions = $core->getUserPermissions($user_id);
@@ -305,8 +313,8 @@
 			if (count($v['p']) > 0)
 			{
-				echo '<h4><a href="blog.php?id='.html::escapeHTML($k).'">'.
-				html::escapeHTML($v['name']).'</a> ('.html::escapeHTML($k).') - '.
-				'<a href="permissions.php?blog_id[]='.$k.'&amp;user_id[]='.$user_id.'">'
-				.__('Change permissions').'</a></h4>';
+				echo 
+				'<form action="users_actions.php" method="post">'.
+				'<h4><a href="blog.php?id='.html::escapeHTML($k).'">'.
+				html::escapeHTML($v['name']).'</a> ('.html::escapeHTML($k).')</h4>';
 				
 				echo '<ul>';
@@ -316,13 +324,18 @@
 					}
 				}
-				echo '</ul>';
+				echo '</ul>'.
+				'<p><input type="submit" value="'.__('Change permissions').'" />'.
+				form::hidden(array('redir'),'user.php?id='.$user_id).
+				form::hidden(array('action'),'perms').
+				form::hidden(array('users[]'),$user_id).
+				form::hidden(array('blogs[]'),$k).
+				$core->formNonce().
+				'</p>'.
+				'</form>';
 			}
 		}
 	}
 	
-	echo
-	'<p><a href="permissions_blog.php?user_id[]='.$user_id.'">'.
-	__('Add new permissions').'</a></p>'.
-	'</div>';
+	echo '</div>';
 }
 
Index: admin/users.php
===================================================================
--- admin/users.php	(revision 782)
+++ admin/users.php	(revision 860)
@@ -15,31 +15,7 @@
 dcPage::checkSuper();
 
-# Delete users
-if (!empty($delete_users))
-{
-	foreach ($delete_users as $u)
-	{
-		try
-		{
-			# --BEHAVIOR-- adminBeforeUserDelete
-			$core->callBehavior('adminBeforeUserDelete',$u);
-			if ($u != $core->auth->userID()) {
-				$core->delUser($u);
-			}
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
-	}
-	if (!$core->error->flag()) {
-		http::redirect('users.php?del=1');
-	}
-}
-
-
 # Creating filter combo boxes
 $sortby_combo = array(
-__('Username') => 'U.user_id',
+__('Username') => 'user_id',
 __('Last Name') => 'user_name',
 __('First Name') => 'user_firstname',
@@ -55,5 +31,5 @@
 # Actions combo box
 $combo_action = array(
-	__('Set permissions') => 'setpermissions',
+	__('Set permissions') => 'blogs',
 	__('Delete') => 'deleteuser'
 );
@@ -64,14 +40,18 @@
 
 # Get users
-$user_list = new adminUserList($core);
+$page = !empty($_GET['page']) ? $_GET['page'] : 1;
+$nb_per_page =  30;
+
+if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
+	$nb_per_page = $_GET['nb'];
+}
 
 $q = !empty($_GET['q']) ? $_GET['q'] : '';
+$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'user_id';
+$order = !empty($_GET['order']) ?		$_GET['order'] : 'asc';
+
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 
 $show_filters = false;
-
-$params = new ArrayObject();
-
-# - Limit, sortby and order filter
-$params = $user_list->applyFilters($params);
 
 # - Search filter
@@ -81,11 +61,29 @@
 }
 
+# - Sortby and order filter
+if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if ($order !== '' && in_array($order,$order_combo)) {
+		$params['order'] = $sortby.' '.$order;
+	} else {
+		$order='asc';
+	}
+	
+	if ($sortby != 'user_id' || $order != 'asc') {
+		$show_filters = true;
+	}
+} else {
+	$sortby = 'user_id';
+	$order = 'asc';
+}
+
+# Get users
 try {
 	$rs = $core->getUsers($params);
 	$counter = $core->getUsers($params,1);
-	$user_list->setItems($rs,$counter->f(0));
+	$user_list = new adminUserList($core,$rs,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
 }
+
 
 /* DISPLAY
@@ -96,5 +94,5 @@
 }
 
-dcPage::open(__('users'),$starting_script);
+dcPage::open(__('Users'),$starting_script);
 
 if (!$core->error->flag())
@@ -102,4 +100,7 @@
 	if (!empty($_GET['del'])) {
 		echo '<p class="message">'.__('User has been successfully removed.').'</p>';
+	}
+	if (!empty($_GET['upd'])) {
+			echo '<p class="message">'.__('The permissions have been successfully updated.').'</p>';
 	}
 	
@@ -114,10 +115,23 @@
 	echo
 	'<form action="users.php" method="get" id="filters-form">'.
-	'<fieldset><legend>'.__('Filters').'</legend>'.
+	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
 	
+	'<div class="col">'.
+	'<p><label for="sortby">'.__('Order by:').' '.
+	form::combo('sortby',$sortby_combo,$sortby).
+	'</label> '.
+	'<label for="order">'.__('Sort:').' '.
+	form::combo('order',$order_combo,$order).
+	'</label></p>'.
+	'</div>'.
+	
+	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
 	'</label></p>'.
-	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
+	__('Users per page').'</label> '.
+	'<input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'</div>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -126,5 +140,6 @@
 	
 	# Show users
-	$user_list->display('<form action="dispatcher.php" method="get" id="form-users">'.
+	$user_list->display($page,$nb_per_page,
+	'<form action="users_actions.php" method="post" id="form-users">'.
 	
 	'%s'.
@@ -133,11 +148,16 @@
 	'<p class="col checkboxes-helpers"></p>'.
 	
-	'<p class="col right"><label for="dispatch_action" class="classic">'.
+	'<p class="col right"><label for="action" class="classic">'.
 	__('Selected users action:').' '.
-	form::combo('dispatch_action',$combo_action).
+	form::combo('action',$combo_action).
 	'</label> '.
 	'<input type="submit" value="'.__('ok').'" />'.
+	form::hidden(array('q'),html::escapeHTML($q)).
+	form::hidden(array('sortby'),$sortby).
+	form::hidden(array('order'),$order).
+	form::hidden(array('page'),$page).
+	form::hidden(array('nb'),$nb_per_page).
+	$core->formNonce().
 	'</p>'.
-	$user_list->getFormFieldsAsHidden().
 	'</div>'.
 	'</form>'
Index: admin/users_actions.php
===================================================================
--- admin/users_actions.php	(revision 860)
+++ admin/users_actions.php	(revision 860)
@@ -0,0 +1,284 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+require dirname(__FILE__).'/../inc/admin/prepend.php';
+
+dcPage::checkSuper();
+
+$users = array();
+if (!empty($_POST['users']) && is_array($_POST['users']))
+{
+	foreach ($_POST['users'] as $u)
+	{
+		if ($core->userExists($u)) {
+			$users[] = $u;
+		}
+	}
+}
+
+$blogs = array();
+if (!empty($_POST['blogs']) && is_array($_POST['blogs']))
+{
+	foreach ($_POST['blogs'] as $b)
+	{
+		if ($core->blogExists($b)) {
+			$blogs[] = $b;
+		}
+	}
+}
+
+/* Actions
+-------------------------------------------------------- */
+if (!empty($_POST['action']) && !empty($_POST['users']))
+{
+	$action = $_POST['action'];
+	
+	if (isset($_POST['redir']) && strpos($_POST['redir'],'://') === false)
+	{
+		$redir = $_POST['redir'];
+	}
+	else
+	{
+		$redir =
+		'users.php?q='.$_POST['q'].
+		'&sortby='.$_POST['sortby'].
+		'&order='.$_POST['order'].
+		'&page='.$_POST['page'].
+		'&nb='.$_POST['nb'];
+	}
+	
+	if (empty($users)) {
+		$core->error->add(__('No blog or user given.'));
+	}
+	
+	# --BEHAVIOR-- adminUsersActions
+	$core->callBehavior('adminUsersActions',$core,$users,$blogs,$action,$redir);
+	
+	# Delete users
+	if ($action == 'deleteuser' && !empty($users))
+	{
+		foreach ($users as $u)
+		{
+			try
+			{
+				if ($u == $core->auth->userID()) {
+					throw new Exception(__('Not delete yourself.'));
+				}
+				
+				# --BEHAVIOR-- adminBeforeUserDelete
+				$core->callBehavior('adminBeforeUserDelete',$u);
+				
+				$core->delUser($u);
+			}
+			catch (Exception $e)
+			{
+				$core->error->add($e->getMessage());
+			}
+		}
+		if (!$core->error->flag()) {
+			http::redirect($redir.'&del=1');
+		}
+	}
+	
+	# Update users perms
+	if ($action == 'updateperm' && !empty($users) && !empty($blogs))
+	{
+		try
+		{
+			if (empty($_POST['your_pwd']) || !$core->auth->checkPassword(crypt::hmac(DC_MASTER_KEY,$_POST['your_pwd']))) {
+				throw new Exception(__('Password verification failed'));
+			}
+			
+			foreach ($users as $u)
+			{
+				foreach ($blogs as $b)
+				{
+					$set_perms = array();
+					
+					if (!empty($_POST['perm'][$b]))
+					{
+						foreach ($_POST['perm'][$b] as $perm_id => $v)
+						{
+							if ($v) {
+								$set_perms[$perm_id] = true;
+							}
+						}
+					}
+					
+					$core->setUserBlogPermissions($u,$b,$set_perms,true);
+				}
+			}
+		}
+		catch (Exception $e)
+		{
+			$core->error->add($e->getMessage());
+		}
+		if (!$core->error->flag()) {
+			http::redirect($redir.'&upd=1');
+		}
+	}
+}
+
+/* DISPLAY
+-------------------------------------------------------- */
+dcPage::open(
+	__('Users'),
+	dcPage::jsLoad('js/_users_actions.js').
+	# --BEHAVIOR-- adminUsersActionsHeaders
+	$core->callBehavior('adminUsersActionsHeaders')
+);
+
+if (!isset($action)) {
+	dcPage::close();
+	exit;
+}
+
+$hidden_fields = '';
+foreach($users as $u) {
+	$hidden_fields .= form::hidden(array('users[]'),$u);
+}
+
+if (isset($_POST['redir']) && strpos($_POST['redir'],'://') === false)
+{
+	$hidden_fields .= form::hidden(array('redir'),html::escapeURL($_POST['redir']));
+}
+else
+{
+	$hidden_fields .=
+	form::hidden(array('q'),html::escapeHTML($_POST['q'])).
+	form::hidden(array('sortby'),$_POST['sortby']).
+	form::hidden(array('order'),$_POST['order']).
+	form::hidden(array('page'),$_POST['page']).
+	form::hidden(array('nb'),$_POST['nb']);
+}
+
+# --BEHAVIOR-- adminUsersActionsContent
+$core->callBehavior('adminUsersActionsContent',$core,$action,$hidden_fields);
+
+# Blog list where to set permissions
+if (!empty($users) && empty($blogs) && $action == 'blogs')
+{
+	try {
+		$rs = $core->getBlogs();
+		$nb_blog = $rs->count();
+	} catch (Exception $e) { }
+	
+	foreach ($users as $u) {
+		$user_list[] = '<a href="user.php?id='.$u.'">'.$u.'</a>';
+	}
+	
+	echo 
+	'<h2><a href="users.php">'.__('Users').'</a> &rsaquo; <span class="page-title">'.__('Permissions').'</span></h2>'.
+	'<p>'.sprintf(
+		__('Choose one or more blogs to which you want to give permissions to users %s.'),
+		implode(', ',$user_list)
+	).'</p>';
+	
+	if ($nb_blog == 0)
+	{
+		echo '<p><strong>'.__('No blog').'</strong></p>';
+	}
+	else
+	{
+		echo
+		'<form action="users_actions.php" method="post" id="form-blogs">'.
+		'<table class="clear"><tr>'.
+		'<th class="nowrap" colspan="2">'.__('Blog ID').'</th>'.
+		'<th class="nowrap">'.__('Blog name').'</th>'.
+		'<th class="nowrap">'.__('Entries').'</th>'.
+		'<th class="nowrap">'.__('Status').'</th>'.
+		'</tr>';
+		
+		while ($rs->fetch())
+		{
+			$img_status = $rs->blog_status == 1 ? 'check-on' : 'check-off';
+			$txt_status = $core->getBlogStatus($rs->blog_status);
+			$img_status = sprintf('<img src="images/%1$s.png" alt="%2$s" title="%2$s" />',$img_status,$txt_status);
+			
+			echo
+			'<tr class="line">'.
+			'<td class="nowrap">'.
+			form::checkbox(array('blogs[]'),$rs->blog_id,'','','',false,'title="'.__('select').' '.$rs->blog_id.'"').'</td>'.
+			'<td class="nowrap">'.$rs->blog_id.'</td>'.
+			'<td class="maximal">'.html::escapeHTML($rs->blog_name).'</td>'.
+			'<td class="nowrap">'.$core->countBlogPosts($rs->blog_id).'</td>'.
+			'<td class="status">'.$img_status.'</td>'.
+			'</tr>';
+		}
+		
+		echo
+		'</table>'.
+		'<p class="checkboxes-helpers"></p>'.
+		'<p><input type="submit" value="'.__('Set permissions').'" />'.
+		$hidden_fields.
+		form::hidden(array('action'),'perms').
+		$core->formNonce().'</p>'.
+		'</form>';
+	}
+}
+# Permissions list for each selected blogs
+elseif (!empty($blogs) && !empty($users) && $action == 'perms')
+{
+	$user_perm = array();
+	if (count($users) == 1) {
+			$user_perm = $core->getUserPermissions($users[0]);	
+	}
+	
+	foreach ($users as $u) {
+		$user_list[] = '<a href="user.php?id='.$u.'">'.$u.'</a>';
+	}
+	
+	echo 
+	'<h2><a href="users.php">'.__('Users').'</a> &rsaquo; <span class="page-title">'.__('Permissions').'</span></h2>'.
+	'<p>'.sprintf(
+		__('You are about to change permissions on the following blogs for users %s.'),
+		implode(', ',$user_list)
+	).'</p>'.
+	'<form id="permissions-form" action="users_actions.php" method="post">';
+	
+	foreach ($blogs as $b)
+	{
+		echo '<h3><a href="blog.php?id='.html::escapeHTML($b).'">'.html::escapeHTML($b).'</a>'.
+		form::hidden(array('blogs[]'),$b).'</h3>';
+		
+		foreach ($core->auth->getPermissionsTypes() as $perm_id => $perm)
+		{
+			$checked = false;
+			
+			if (count($users) == 1) {
+				$checked = isset($user_perm[$b]['p'][$perm_id]) && $user_perm[$b]['p'][$perm_id];
+			}
+			
+			echo
+			'<p><label for="perm'.html::escapeHTML($b).html::escapeHTML($perm_id).'" class="classic">'.
+			form::checkbox(array('perm['.html::escapeHTML($b).']['.html::escapeHTML($perm_id).']','perm'.html::escapeHTML($b).html::escapeHTML($perm_id)),
+			1,$checked).' '.
+			__($perm).'</label></p>';
+		}
+	}
+	
+	echo
+	'<fieldset><legend>'.__('Validate permissions').'</legend>'.
+	'<p><label for="your_pwd">'.__('Your password:').
+	form::password('your_pwd',20,255).'</label></p>'.
+	'</fieldset>'.
+	'<p><input type="submit" accesskey="s" value="'.__('Save').'" />'.
+	$hidden_fields.
+	form::hidden(array('action'),'updateperm').
+	$core->formNonce().'</p>'.
+	'</form>';
+}
+
+echo '<p><a class="back" href="'.html::escapeURL($redir).'">'.__('back').'</a></p>';
+
+dcPage::close();
+?>
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 782)
+++ inc/admin/lib.dc.page.php	(revision 812)
@@ -124,5 +124,5 @@
 		
 		'<div id="header">'.
-		'<ul id="prelude"><li><a href="#content">Aller au contenu</a></li><li><a href="#main-menu">Aller au menu</a></li></ul>'."\n".
+		'<ul id="prelude"><li><a href="#content">'.__('Go to the content').'</a></li><li><a href="#main-menu">'.__('Go to the menu').'</a></li></ul>'."\n".
 		'<div id="top"><h1><a href="index.php">'.DC_VENDOR_NAME.'</a></h1></div>'."\n";	
 		
@@ -515,11 +515,4 @@
 	}
 	
-	public static function jqueryUI()
-	{
-		return
-		'<link rel="stylesheet" type="text/css" href="style/jquery-ui-1.8.16.custom.css" />'."\n".
-		self::jsLoad('js/jquery/jquery-ui-1.8.16.custom.min.js');
-	}
-
 	public static function jsColorPicker()
 	{
